#include <math.h>

inline void getRigidBodyEnergyGradienti3D(
  double alpha,
  double beta,
  double edge2LengthOriginal,
  const double *tangentOriginalRigidBody,
  const double *materialNormalOriginalRigidBody,
  const double *tangentReferenceOriginal,
  const double *normalReferenceOriginal,
  double referenceFrameTwist,
  const double *x1,
  const double *rigidBodyAngles,
  const double *x2,
  double theta2,
  double *EnergyGradienti)
{
  double t10;
  double t100;
  double t1004;
  double t102;
  double t104;
  double t1042;
  double t1043;
  double t1044;
  double t1047;
  double t1050;
  double t1053;
  double t1056;
  double t106;
  double t1062;
  double t1068;
  double t107;
  double t1076;
  double t1079;
  double t1084;
  double t1087;
  double t109;
  double t1097;
  double t11;
  double t110;
  double t1100;
  double t1108;
  double t111;
  double t1114;
  double t1120;
  double t1126;
  double t113;
  double t1131;
  double t1136;
  double t1138;
  double t114;
  double t1148;
  double t115;
  double t1151;
  double t116;
  double t1161;
  double t1166;
  double t118;
  double t1180;
  double t1183;
  double t1186;
  double t1192;
  double t12;
  double t120;
  double t1202;
  double t1205;
  double t1220;
  double t1223;
  double t1233;
  double t124;
  double t1248;
  double t1251;
  double t127;
  double t1272;
  double t1275;
  double t1293;
  double t1298;
  double t13;
  double t130;
  double t1301;
  double t1310;
  double t1319;
  double t1326;
  double t1335;
  double t134;
  double t1344;
  double t138;
  double t1392;
  double t1398;
  double t14;
  double t140;
  double t1404;
  double t1407;
  double t141;
  double t1411;
  double t1417;
  double t142;
  double t1421;
  double t1427;
  double t1431;
  double t1437;
  double t144;
  double t1445;
  double t145;
  double t1450;
  double t146;
  double t1462;
  double t147;
  double t1475;
  double t148;
  double t1487;
  double t149;
  double t1490;
  double t15;
  double t1501;
  double t151;
  double t1512;
  double t1530;
  double t1536;
  double t154;
  double t1542;
  double t156;
  double t1571;
  double t1573;
  double t1576;
  double t1583;
  double t1587;
  double t1589;
  double t1592;
  double t1595;
  double t1598;
  double t16;
  double t1600;
  double t1602;
  double t1608;
  double t161;
  double t1613;
  double t1619;
  double t1624;
  double t163;
  double t1630;
  double t1638;
  double t1643;
  double t1655;
  double t1668;
  double t168;
  double t1680;
  double t1683;
  double t1694;
  double t17;
  double t1705;
  double t1723;
  double t1729;
  double t1735;
  double t176;
  double t1765;
  double t1766;
  double t1769;
  double t177;
  double t1773;
  double t1775;
  double t1780;
  double t1782;
  double t1786;
  double t1791;
  double t1797;
  double t18;
  double t180;
  double t1809;
  double t1823;
  double t1835;
  double t1838;
  double t1849;
  double t1860;
  double t1878;
  double t188;
  double t1885;
  double t1892;
  double t19;
  double t191;
  double t1921;
  double t1922;
  double t1925;
  double t1928;
  double t1931;
  double t1934;
  double t1940;
  double t1946;
  double t1954;
  double t1957;
  double t1962;
  double t1965;
  double t1975;
  double t1978;
  double t1986;
  double t1992;
  double t1998;
  double t20;
  double t2004;
  double t2009;
  double t201;
  double t2014;
  double t2016;
  double t2026;
  double t2029;
  double t2039;
  double t2044;
  double t2058;
  double t2061;
  double t2064;
  double t2065;
  double t207;
  double t2070;
  double t2080;
  double t2083;
  double t2090;
  double t2098;
  double t21;
  double t2101;
  double t2108;
  double t2111;
  double t2125;
  double t2126;
  double t2129;
  double t2146;
  double t2150;
  double t2153;
  double t2155;
  double t2162;
  double t217;
  double t2171;
  double t2176;
  double t2179;
  double t2188;
  double t219;
  double t2197;
  double t22;
  double t2204;
  double t2213;
  double t2222;
  double t223;
  double t224;
  double t2268;
  double t2269;
  double t227;
  double t2272;
  double t2275;
  double t2278;
  double t228;
  double t2281;
  double t2287;
  double t2293;
  double t230;
  double t2301;
  double t2304;
  double t2309;
  double t231;
  double t2312;
  double t232;
  double t2322;
  double t2325;
  double t2333;
  double t2339;
  double t2345;
  double t235;
  double t2351;
  double t2356;
  double t236;
  double t2361;
  double t2363;
  double t2373;
  double t2376;
  double t2386;
  double t239;
  double t2391;
  double t24;
  double t240;
  double t2405;
  double t2408;
  double t241;
  double t2411;
  double t2417;
  double t2427;
  double t2430;
  double t244;
  double t2445;
  double t2448;
  double t245;
  double t2458;
  double t2473;
  double t2476;
  double t248;
  double t2497;
  double t25;
  double t2500;
  double t2518;
  double t2523;
  double t2526;
  double t2535;
  double t254;
  double t2544;
  double t2551;
  double t2560;
  double t2569;
  double t26;
  double t260;
  double t261;
  double t2615;
  double t2616;
  double t2619;
  double t2622;
  double t2625;
  double t2628;
  double t2634;
  double t2640;
  double t2648;
  double t2651;
  double t2656;
  double t2659;
  double t2669;
  double t2672;
  double t2680;
  double t2686;
  double t269;
  double t2692;
  double t2698;
  double t27;
  double t270;
  double t2703;
  double t2708;
  double t2710;
  double t2720;
  double t2723;
  double t273;
  double t2733;
  double t2738;
  double t275;
  double t2752;
  double t2755;
  double t2758;
  double t2764;
  double t277;
  double t2774;
  double t2777;
  double t2792;
  double t2795;
  double t2805;
  double t281;
  double t2820;
  double t2823;
  double t284;
  double t2844;
  double t2847;
  double t285;
  double t2865;
  double t2870;
  double t2873;
  double t2882;
  double t2891;
  double t2898;
  double t29;
  double t2907;
  double t2916;
  double t295;
  double t2965;
  double t2968;
  double t297;
  double t2975;
  double t298;
  double t2987;
  double t3;
  double t300;
  double t303;
  double t304;
  double t307;
  double t309;
  double t31;
  double t310;
  double t316;
  double t317;
  double t32;
  double t323;
  double t324;
  double t330;
  double t335;
  double t337;
  double t338;
  double t339;
  double t34;
  double t343;
  double t345;
  double t355;
  double t358;
  double t360;
  double t367;
  double t368;
  double t37;
  double t373;
  double t374;
  double t377;
  double t378;
  double t390;
  double t393;
  double t397;
  double t398;
  double t4;
  double t403;
  double t406;
  double t416;
  double t419;
  double t424;
  double t425;
  double t436;
  double t439;
  double t444;
  double t45;
  double t451;
  double t457;
  double t468;
  double t47;
  double t471;
  double t474;
  double t476;
  double t477;
  double t478;
  double t48;
  double t481;
  double t49;
  double t491;
  double t497;
  double t498;
  double t499;
  double t5;
  double t50;
  double t500;
  double t501;
  double t503;
  double t511;
  double t512;
  double t513;
  double t516;
  double t52;
  double t523;
  double t524;
  double t526;
  double t529;
  double t536;
  double t537;
  double t539;
  double t542;
  double t547;
  double t55;
  double t551;
  double t552;
  double t556;
  double t559;
  double t56;
  double t567;
  double t579;
  double t58;
  double t584;
  double t587;
  double t596;
  double t6;
  double t60;
  double t602;
  double t606;
  double t61;
  double t612;
  double t615;
  double t625;
  double t626;
  double t63;
  double t632;
  double t636;
  double t64;
  double t642;
  double t65;
  double t66;
  double t662;
  double t67;
  double t69;
  double t692;
  double t693;
  double t694;
  double t697;
  double t7;
  double t70;
  double t700;
  double t703;
  double t706;
  double t71;
  double t712;
  double t718;
  double t726;
  double t729;
  double t73;
  double t734;
  double t737;
  double t74;
  double t747;
  double t750;
  double t758;
  double t76;
  double t764;
  double t770;
  double t776;
  double t781;
  double t786;
  double t788;
  double t798;
  double t8;
  double t80;
  double t801;
  double t811;
  double t816;
  double t82;
  double t83;
  double t830;
  double t833;
  double t836;
  double t842;
  double t85;
  double t852;
  double t855;
  double t86;
  double t870;
  double t873;
  double t88;
  double t883;
  double t898;
  double t901;
  double t91;
  double t922;
  double t925;
  double t94;
  double t943;
  double t948;
  double t95;
  double t951;
  double t96;
  double t960;
  double t969;
  double t97;
  double t976;
  double t98;
  double t985;
  double t99;
  double t994;
  t3 = x2[0];
  t6 = x1[0];
  t4 = t3 - 0.1e1 * t6;
  t5 = t4 * t4;
  t17 = x2[1];
  t20 = x1[1];
  t7 = t17 - 0.1e1 * t20;
  t8 = t7 * t7;
  t26 = x2[2];
  t27 = x1[2];
  t10 = t26 - 0.1e1 * t27;
  t11 = t10 * t10;
  t12 = t5 + t8 + t11;
  t13 = sqrt(t12);
  t14 = 0.1e1 / t13;
  t15 = t14 * t7;
  t29 = tangentReferenceOriginal[0];
  t16 = t29 * t14;
  t18 = 0.1e1 * t16 * t4;
  t32 = tangentReferenceOriginal[1];
  t19 = t32 * t14;
  t21 = 0.1e1 * t19 * t7;
  t34 = tangentReferenceOriginal[2];
  t22 = t34 * t14;
  t24 = 0.1e1 * t22 * t10;
  t25 = t18 + t21 + t24;
  t31 = 0.1e1 * t19 * t10 - 0.1e1 * t22 * t7;
  t37 = -0.1e1 * t16 * t10 + 0.1e1 * t22 * t4;
  t45 = 0.1e1 * t16 * t7 - 0.1e1 * t19 * t4;
  t56 = normalReferenceOriginal[0];
  t58 = normalReferenceOriginal[1];
  t61 = normalReferenceOriginal[2];
  t47 = t31 * t56 + t37 * t58 + t45 * t61;
  t48 = 0.1e1 + t18 + t21 + t24;
  t49 = 0.1e1 / t48;
  t50 = t47 * t49;
  t52 = t25 * t61 + t31 * t58 - t37 * t56 + t45 * t50;
  t55 = t14 * t10;
  t60 = t25 * t58 - t31 * t61 + t37 * t50 + t45 * t56;
  t63 = 0.1e1 * t15 * t52 - 0.1e1 * t55 * t60;
  t64 = cos(referenceFrameTwist);
  t94 = rigidBodyAngles[2];
  t65 = cos(t94);
  t96 = rigidBodyAngles[1];
  t66 = cos(t96);
  t67 = t65 * t66;
  t69 = sin(t96);
  t70 = t65 * t69;
  t99 = rigidBodyAngles[0];
  t71 = sin(t99);
  t73 = sin(t94);
  t74 = cos(t99);
  t76 = t70 * t71 - t73 * t74;
  t80 = t70 * t74 + t71 * t73;
  t111 = tangentOriginalRigidBody[0];
  t113 = tangentOriginalRigidBody[1];
  t118 = tangentOriginalRigidBody[2];
  t82 = t111 * t67 + t113 * t76 + t118 * t80;
  t83 = t82 * t14;
  t85 = 0.1e1 * t83 * t4;
  t86 = t73 * t66;
  t88 = t73 * t69;
  t91 = t65 * t74 + t71 * t88;
  t95 = -t65 * t71 + t74 * t88;
  t97 = t111 * t86 + t113 * t91 + t118 * t95;
  t98 = t97 * t14;
  t100 = 0.1e1 * t98 * t7;
  t102 = t66 * t71;
  t104 = t66 * t74;
  t106 = t102 * t113 + t104 * t118 - t111 * t69;
  t107 = t106 * t14;
  t109 = 0.1e1 * t107 * t10;
  t110 = t85 + t100 + t109;
  t138 = materialNormalOriginalRigidBody[0];
  t142 = materialNormalOriginalRigidBody[1];
  t148 = materialNormalOriginalRigidBody[2];
  t114 = t138 * t67 + t142 * t76 + t148 * t80;
  t115 = t110 * t114;
  t116 = t83 * t10;
  t120 = -0.1e1 * t116 + 0.1e1 * t107 * t4;
  t124 = t102 * t142 + t104 * t148 - t138 * t69;
  t127 = 0.1e1 * t83 * t7;
  t130 = t127 - 0.1e1 * t98 * t4;
  t134 = t138 * t86 + t142 * t91 + t148 * t95;
  t140 = 0.1e1 * t98 * t10 - 0.1e1 * t107 * t7;
  t141 = t114 * t140;
  t144 = t120 * t134 + t124 * t130 + t141;
  t145 = 0.1e1 + t85 + t100 + t109;
  t146 = 0.1e1 / t145;
  t147 = t146 * t144;
  t149 = t120 * t124 - t130 * t134 + t140 * t147 + t115;
  t151 = sin(referenceFrameTwist);
  t154 = t120 * t114;
  t156 = t110 * t124 + t130 * t147 + t134 * t140 - t154;
  t161 = t130 * t114;
  t163 = t110 * t134 + t120 * t147 - t124 * t140 + t161;
  t168 = t14 * t4;
  t176 = 0.1e1 - t64;
  t177 = (0.1e1 * t168 * t149 + 0.1e1 * t15 * t163 + 0.1e1 * t55 * t156) * t176;
  t180 = t64 * t149 + t151 * (0.1e1 * t15 * t156 - 0.1e1 * t55 * t163) + 0.1e1 * t177 * t168;
  t188 = t25 * t56 + t31 * t50 + t37 * t61 - t45 * t58;
  t191 = -0.1e1 * t168 * t52 + 0.1e1 * t55 * t188;
  t201 = t64 * t163 + t151 * (-0.1e1 * t168 * t156 + 0.1e1 * t55 * t149) + 0.1e1 * t177 * t15;
  t207 = 0.1e1 * t168 * t60 - 0.1e1 * t15 * t188;
  t217 = t64 * t156 + t151 * (0.1e1 * t168 * t163 - 0.1e1 * t15 * t149) + 0.1e1 * t177 * t55;
  t219 = t180 * t63 + t191 * t201 + t207 * t217;
  t223 = t180 * t188 + t201 * t60 + t217 * t52;
  t224 = atan2(t219, t223);
  t227 = t14 / t12;
  t228 = t227 * t7;
  t230 = 0.2e1 * t6;
  t231 = -0.2e1 * t3 + t230;
  t232 = t52 * t231;
  t235 = t29 * t227;
  t236 = t4 * t231;
  t239 = 0.1e1 * t16;
  t240 = t32 * t227;
  t241 = t7 * t231;
  t244 = t34 * t227;
  t245 = t10 * t231;
  t248 = -0.5000000000e0 * t235 * t236 - t239 - 0.5000000000e0 * t240 * t241 - 0.5000000000e0 * t244 * t245;
  t254 = -0.5000000000e0 * t240 * t245 + 0.5000000000e0 * t244 * t241;
  t260 = 0.1e1 * t22;
  t261 = 0.5000000000e0 * t235 * t245 - 0.5000000000e0 * t244 * t236 - t260;
  t269 = 0.1e1 * t19;
  t270 = -0.5000000000e0 * t235 * t241 + 0.5000000000e0 * t240 * t236 + t269;
  t273 = (t254 * t56 + t261 * t58 + t270 * t61) * t49;
  t275 = t48 * t48;
  t277 = t47 / t275;
  t297 = t277 * t45;
  t281 = -t248 * t297 + t248 * t61 + t254 * t58 - t261 * t56 + t270 * t50 + t273 * t45;
  t284 = t10 * t227;
  t285 = t60 * t231;
  t309 = t277 * t37;
  t295 = -t248 * t309 + t248 * t58 - t254 * t61 + t261 * t50 + t270 * t56 + t273 * t37;
  t298 = -0.5000000000e0 * t228 * t232 + 0.1e1 * t15 * t281 + 0.5000000000e0 * t284 * t285 - 0.1e1 * t55 * t295;
  t300 = t82 * t227;
  t303 = 0.1e1 * t83;
  t304 = t97 * t227;
  t307 = t106 * t227;
  t310 = -0.5000000000e0 * t300 * t236 - t303 - 0.5000000000e0 * t304 * t241 - 0.5000000000e0 * t307 * t245;
  t316 = 0.1e1 * t107;
  t317 = 0.5000000000e0 * t300 * t245 - 0.5000000000e0 * t307 * t236 - t316;
  t323 = 0.1e1 * t98;
  t324 = -0.5000000000e0 * t300 * t241 + 0.5000000000e0 * t304 * t236 + t323;
  t330 = -0.5000000000e0 * t304 * t245 + 0.5000000000e0 * t307 * t241;
  t335 = (t114 * t330 + t124 * t324 + t134 * t317) * t146;
  t337 = t145 * t145;
  t338 = 0.1e1 / t337;
  t339 = t144 * t338;
  t360 = t339 * t140;
  t343 = t114 * t310 + t124 * t317 - t134 * t324 + t140 * t335 + t147 * t330 - t310 * t360;
  t345 = t156 * t231;
  t367 = t339 * t130;
  t355 = -t114 * t317 + t124 * t310 + t130 * t335 + t134 * t330 + t147 * t324 - t310 * t367;
  t358 = t163 * t231;
  t377 = t339 * t120;
  t368 = t114 * t324 + t120 * t335 - t124 * t330 + t134 * t310 + t147 * t317 - t310 * t377;
  t373 = t227 * t4;
  t374 = t149 * t231;
  t378 = 0.1e1 * t14 * t149;
  t390 = (-0.5000000000e0 * t373 * t374 - t378 + 0.1e1 * t168 * t343 - 0.5000000000e0 * t228 * t358 + 0.1e1 * t15 * t368 - 0.5000000000e0 * t284 * t345 + 0.1e1 * t55 * t355) * t176;
  t393 = t373 * t231;
  t397 = 0.1e1 * t177 * t14;
  t398 = t64 * t343 + (-0.5000000000e0 * t228 * t345 + 0.1e1 * t15 * t355 + 0.5000000000e0 * t284 * t358 - 0.1e1 * t55 * t368) * t151 + 0.1e1 * t390 * t168 - 0.5000000000e0 * t177 * t393 - t397;
  t403 = 0.1e1 * t14 * t52;
  t406 = t188 * t231;
  t424 = t277 * t31;
  t416 = -t248 * t424 + t248 * t56 + t254 * t50 + t261 * t61 - t270 * t58 + t273 * t31;
  t419 = 0.5000000000e0 * t373 * t232 + t403 - 0.1e1 * t168 * t281 - 0.5000000000e0 * t284 * t406 + 0.1e1 * t55 * t416;
  t425 = 0.1e1 * t14 * t156;
  t436 = t228 * t231;
  t439 = t64 * t368 + t151 * (0.5000000000e0 * t373 * t345 + t425 - 0.1e1 * t168 * t355 - 0.5000000000e0 * t284 * t374 + 0.1e1 * t55 * t343) + 0.1e1 * t390 * t15 - 0.5000000000e0 * t177 * t436;
  t444 = 0.1e1 * t14 * t60;
  t451 = -0.5000000000e0 * t373 * t285 - t444 + 0.1e1 * t168 * t295 + 0.5000000000e0 * t228 * t406 - 0.1e1 * t15 * t416;
  t457 = 0.1e1 * t14 * t163;
  t468 = t284 * t231;
  t471 = t64 * t355 + t151 * (-0.5000000000e0 * t373 * t358 - t457 + 0.1e1 * t168 * t368 + 0.5000000000e0 * t228 * t374 - 0.1e1 * t15 * t343) + 0.1e1 * t390 * t55 - 0.5000000000e0 * t177 * t468;
  t474 = 0.1e1 / t223;
  t476 = t219 * t219;
  t477 = t223 * t223;
  t478 = 0.1e1 / t477;
  t481 = 0.1e1 / (t476 * t478 + 0.1e1);
  t491 = t478 * t481;
  t497 = alpha * edge2LengthOriginal;
  t498 = edge2LengthOriginal * edge2LengthOriginal;
  t499 = 0.1e1 / t498;
  t500 = t146 * t140;
  t501 = cos(theta2);
  t503 = sin(theta2);
  t511 = 0.1e1 * t168 * t188 + 0.1e1 * t15 * t60 + 0.1e1 * t55 * t52;
  t512 = 0.1e1 - t501;
  t513 = t511 * t512;
  t516 = t501 * t52 + t503 * t207 + 0.1e1 * t513 * t55;
  t523 = t501 * t60 + t503 * t191 + 0.1e1 * t513 * t15;
  t524 = t55 * t523;
  t526 = 0.1e1 * t15 * t516 - 0.1e1 * t524;
  t529 = t146 * t120;
  t536 = t501 * t188 + t503 * t63 + 0.1e1 * t513 * t168;
  t537 = t55 * t536;
  t539 = -0.1e1 * t168 * t516 + 0.1e1 * t537;
  t542 = t146 * t130;
  t547 = 0.1e1 * t168 * t523 - 0.1e1 * t15 * t536;
  t551 = t499 * (0.2e1 * t500 * t526 + 0.2e1 * t529 * t539 + 0.2e1 * t542 * t547);
  t552 = t338 * t140;
  t556 = t146 * t330;
  t559 = t516 * t231;
  t567 = 0.1e1 * t14 * t188;
  t579 = (-0.5000000000e0 * t373 * t406 - t567 + 0.1e1 * t168 * t416 - 0.5000000000e0 * t228 * t285 + 0.1e1 * t15 * t295 - 0.5000000000e0 * t284 * t232 + 0.1e1 * t55 * t281) * t512;
  t584 = t501 * t281 + t503 * t451 + 0.1e1 * t579 * t55 - 0.5000000000e0 * t513 * t468;
  t587 = t523 * t231;
  t596 = t501 * t295 + t503 * t419 + 0.1e1 * t579 * t15 - 0.5000000000e0 * t513 * t436;
  t602 = t338 * t120;
  t606 = t146 * t317;
  t612 = 0.1e1 * t14 * t516;
  t615 = t536 * t231;
  t625 = 0.1e1 * t513 * t14;
  t626 = t501 * t416 + t503 * t298 + 0.1e1 * t579 * t168 - 0.5000000000e0 * t513 * t393 - t625;
  t632 = t338 * t130;
  t636 = t146 * t324;
  t642 = 0.1e1 * t14 * t523;
  t662 = t499 * (-0.2e1 * t500 * t536 - 0.2e1 * t529 * t523 - 0.2e1 * t542 * t516);
  t692 = 0.2e1 * t20;
  t693 = -0.2e1 * t17 + t692;
  t694 = t52 * t693;
  t697 = t4 * t693;
  t700 = t7 * t693;
  t703 = t10 * t693;
  t706 = -0.5000000000e0 * t235 * t697 - 0.5000000000e0 * t240 * t700 - t269 - 0.5000000000e0 * t244 * t703;
  t712 = -0.5000000000e0 * t240 * t703 + 0.5000000000e0 * t244 * t700 + t260;
  t718 = 0.5000000000e0 * t235 * t703 - 0.5000000000e0 * t244 * t697;
  t726 = -0.5000000000e0 * t235 * t700 - t239 + 0.5000000000e0 * t240 * t697;
  t729 = (t56 * t712 + t58 * t718 + t61 * t726) * t49;
  t734 = -t297 * t706 + t45 * t729 + t50 * t726 - t56 * t718 + t58 * t712 + t61 * t706;
  t737 = t60 * t693;
  t747 = -t309 * t706 + t37 * t729 + t50 * t718 + t56 * t726 + t58 * t706 - t61 * t712;
  t750 = -0.5000000000e0 * t228 * t694 - t403 + 0.1e1 * t15 * t734 + 0.5000000000e0 * t284 * t737 - 0.1e1 * t55 * t747;
  t758 = -0.5000000000e0 * t300 * t697 - 0.5000000000e0 * t304 * t700 - t323 - 0.5000000000e0 * t307 * t703;
  t764 = 0.5000000000e0 * t300 * t703 - 0.5000000000e0 * t307 * t697;
  t770 = -0.5000000000e0 * t300 * t700 - t303 + 0.5000000000e0 * t304 * t697;
  t776 = -0.5000000000e0 * t304 * t703 + 0.5000000000e0 * t307 * t700 + t316;
  t781 = (t114 * t776 + t124 * t770 + t134 * t764) * t146;
  t786 = t114 * t758 + t124 * t764 - t134 * t770 + t140 * t781 + t147 * t776 - t360 * t758;
  t788 = t156 * t693;
  t798 = -t114 * t764 + t124 * t758 + t130 * t781 + t134 * t776 + t147 * t770 - t367 * t758;
  t801 = t163 * t693;
  t811 = t114 * t770 + t120 * t781 - t124 * t776 + t134 * t758 + t147 * t764 - t377 * t758;
  t816 = t149 * t693;
  t830 = (-0.5000000000e0 * t373 * t816 + 0.1e1 * t168 * t786 - 0.5000000000e0 * t228 * t801 - t457 + 0.1e1 * t15 * t811 - 0.5000000000e0 * t284 * t788 + 0.1e1 * t55 * t798) * t176;
  t833 = t373 * t693;
  t836 = t64 * t786 + t151 * (-0.5000000000e0 * t228 * t788 - t425 + 0.1e1 * t15 * t798 + 0.5000000000e0 * t284 * t801 - 0.1e1 * t55 * t811) + 0.1e1 * t830 * t168 - 0.5000000000e0 * t177 * t833;
  t842 = t188 * t693;
  t852 = t31 * t729 - t424 * t706 + t50 * t712 + t56 * t706 - t58 * t726 + t61 * t718;
  t855 = 0.5000000000e0 * t373 * t694 - 0.1e1 * t168 * t734 - 0.5000000000e0 * t284 * t842 + 0.1e1 * t55 * t852;
  t870 = t228 * t693;
  t873 = t64 * t811 + t151 * (0.5000000000e0 * t373 * t788 - 0.1e1 * t168 * t798 - 0.5000000000e0 * t284 * t816 + 0.1e1 * t55 * t786) + 0.1e1 * t830 * t15 - 0.5000000000e0 * t177 * t870 - t397;
  t883 = -0.5000000000e0 * t373 * t737 + 0.1e1 * t168 * t747 + 0.5000000000e0 * t228 * t842 + t567 - 0.1e1 * t15 * t852;
  t898 = t284 * t693;
  t901 = t64 * t798 + t151 * (-0.5000000000e0 * t373 * t801 + 0.1e1 * t168 * t811 + 0.5000000000e0 * t228 * t816 + t378 - 0.1e1 * t15 * t786) + 0.1e1 * t830 * t55 - 0.5000000000e0 * t177 * t898;
  t922 = t146 * t776;
  t925 = t516 * t693;
  t943 = (-0.5000000000e0 * t373 * t842 + 0.1e1 * t168 * t852 - 0.5000000000e0 * t228 * t737 - t444 + 0.1e1 * t15 * t747 - 0.5000000000e0 * t284 * t694 + 0.1e1 * t55 * t734) * t512;
  t948 = t501 * t734 + t503 * t883 + 0.1e1 * t943 * t55 - 0.5000000000e0 * t513 * t898;
  t951 = t523 * t693;
  t960 = t501 * t747 + t503 * t855 + 0.1e1 * t943 * t15 - 0.5000000000e0 * t513 * t870 - t625;
  t969 = t146 * t764;
  t976 = t536 * t693;
  t985 = t501 * t852 + t503 * t750 + 0.1e1 * t943 * t168 - 0.5000000000e0 * t513 * t833;
  t994 = t146 * t770;
  t1004 = 0.1e1 * t14 * t536;
  t1042 = 0.2e1 * t27;
  t1043 = -0.2e1 * t26 + t1042;
  t1044 = t52 * t1043;
  t1047 = t4 * t1043;
  t1050 = t7 * t1043;
  t1053 = t10 * t1043;
  t1056 = -0.5000000000e0 * t235 * t1047 - 0.5000000000e0 * t240 * t1050 - 0.5000000000e0 * t244 * t1053 - t260;
  t1062 = -0.5000000000e0 * t240 * t1053 - t269 + 0.5000000000e0 * t244 * t1050;
  t1068 = 0.5000000000e0 * t235 * t1053 + t239 - 0.5000000000e0 * t244 * t1047;
  t1076 = -0.5000000000e0 * t235 * t1050 + 0.5000000000e0 * t240 * t1047;
  t1079 = (t1062 * t56 + t1068 * t58 + t1076 * t61) * t49;
  t1084 = -t1056 * t297 + t1056 * t61 + t1062 * t58 - t1068 * t56 + t1076 * t50 + t1079 * t45;
  t1087 = t60 * t1043;
  t1097 = -t1056 * t309 + t1056 * t58 - t1062 * t61 + t1068 * t50 + t1076 * t56 + t1079 * t37;
  t1100 = -0.5000000000e0 * t228 * t1044 + 0.1e1 * t15 * t1084 + 0.5000000000e0 * t284 * t1087 + t444 - 0.1e1 * t55 * t1097;
  t1108 = -0.5000000000e0 * t300 * t1047 - 0.5000000000e0 * t304 * t1050 - 0.5000000000e0 * t307 * t1053 - t316;
  t1114 = 0.5000000000e0 * t300 * t1053 + t303 - 0.5000000000e0 * t307 * t1047;
  t1120 = -0.5000000000e0 * t300 * t1050 + 0.5000000000e0 * t304 * t1047;
  t1126 = -0.5000000000e0 * t304 * t1053 - t323 + 0.5000000000e0 * t307 * t1050;
  t1131 = (t1114 * t134 + t1120 * t124 + t1126 * t114) * t146;
  t1136 = t1108 * t114 - t1108 * t360 + t1114 * t124 - t1120 * t134 + t1126 * t147 + t140 * t1131;
  t1138 = t156 * t1043;
  t1148 = t1108 * t124 - t1108 * t367 - t1114 * t114 + t1120 * t147 + t1126 * t134 + t1131 * t130;
  t1151 = t163 * t1043;
  t1161 = t1108 * t134 - t1108 * t377 + t1114 * t147 + t1120 * t114 - t1126 * t124 + t1131 * t120;
  t1166 = t149 * t1043;
  t1180 = (-0.5000000000e0 * t373 * t1166 + 0.1e1 * t168 * t1136 - 0.5000000000e0 * t228 * t1151 + 0.1e1 * t15 * t1161 - 0.5000000000e0 * t284 * t1138 - t425 + 0.1e1 * t55 * t1148) * t176;
  t1183 = t373 * t1043;
  t1186 = t64 * t1136 + t151 * (-0.5000000000e0 * t228 * t1138 + 0.1e1 * t15 * t1148 + 0.5000000000e0 * t284 * t1151 + t457 - 0.1e1 * t55 * t1161) + 0.1e1 * t1180 * t168 - 0.5000000000e0 * t177 * t1183;
  t1192 = t188 * t1043;
  t1202 = -t1056 * t424 + t1056 * t56 + t1062 * t50 + t1068 * t61 - t1076 * t58 + t1079 * t31;
  t1205 = 0.5000000000e0 * t373 * t1044 - 0.1e1 * t168 * t1084 - 0.5000000000e0 * t284 * t1192 - t567 + 0.1e1 * t55 * t1202;
  t1220 = t228 * t1043;
  t1223 = t64 * t1161 + t151 * (0.5000000000e0 * t373 * t1138 - 0.1e1 * t168 * t1148 - 0.5000000000e0 * t284 * t1166 - t378 + 0.1e1 * t55 * t1136) + 0.1e1 * t1180 * t15 - 0.5000000000e0 * t177 * t1220;
  t1233 = -0.5000000000e0 * t373 * t1087 + 0.1e1 * t168 * t1097 + 0.5000000000e0 * t228 * t1192 - 0.1e1 * t15 * t1202;
  t1248 = t284 * t1043;
  t1251 = t64 * t1148 + t151 * (-0.5000000000e0 * t373 * t1151 + 0.1e1 * t168 * t1161 + 0.5000000000e0 * t228 * t1166 - 0.1e1 * t15 * t1136) + 0.1e1 * t1180 * t55 - 0.5000000000e0 * t177 * t1248 - t397;
  t1272 = t146 * t1126;
  t1275 = t516 * t1043;
  t1293 = (-0.5000000000e0 * t373 * t1192 + 0.1e1 * t168 * t1202 - 0.5000000000e0 * t228 * t1087 + 0.1e1 * t15 * t1097 - 0.5000000000e0 * t284 * t1044 - t403 + 0.1e1 * t55 * t1084) * t512;
  t1298 = t501 * t1084 + t503 * t1233 + 0.1e1 * t1293 * t55 - 0.5000000000e0 * t513 * t1248 - t625;
  t1301 = t523 * t1043;
  t1310 = t501 * t1097 + t503 * t1205 + 0.1e1 * t1293 * t15 - 0.5000000000e0 * t513 * t1220;
  t1319 = t146 * t1114;
  t1326 = t536 * t1043;
  t1335 = t501 * t1202 + t503 * t1100 + 0.1e1 * t1293 * t168 - 0.5000000000e0 * t513 * t1183;
  t1344 = t146 * t1120;
  t1392 = (t113 * t80 - t118 * t76) * t14;
  t1398 = (t113 * t95 - t118 * t91) * t14;
  t1404 = (-t102 * t118 + t104 * t113) * t14;
  t1407 = 0.1e1 * t1392 * t4 + 0.1e1 * t1398 * t7 + 0.1e1 * t1404 * t10;
  t1411 = t142 * t80 - t148 * t76;
  t1417 = -0.1e1 * t10 * t1392 + 0.1e1 * t1404 * t4;
  t1421 = -t102 * t148 + t104 * t142;
  t1427 = 0.1e1 * t1392 * t7 - 0.1e1 * t1398 * t4;
  t1431 = t142 * t95 - t148 * t91;
  t1437 = 0.1e1 * t1398 * t10 - 0.1e1 * t1404 * t7;
  t1445 = (t114 * t1437 + t120 * t1431 + t124 * t1427 + t130 * t1421 + t134 * t1417 + t140 * t1411) * t146;
  t1450 = t110 * t1411 + t114 * t1407 + t120 * t1421 + t124 * t1417 - t130 * t1431 - t134 * t1427 + t140 * t1445 - t1407 * t360 + t1437 * t147;
  t1462 = t110 * t1421 - t114 * t1417 - t120 * t1411 + t124 * t1407 + t130 * t1445 + t134 * t1437 + t140 * t1431 - t1407 * t367 + t1427 * t147;
  t1475 = t110 * t1431 + t114 * t1427 + t120 * t1445 - t124 * t1437 + t130 * t1411 + t134 * t1407 - t140 * t1421 - t1407 * t377 + t1417 * t147;
  t1487 = (0.1e1 * t168 * t1450 + 0.1e1 * t15 * t1475 + 0.1e1 * t55 * t1462) * t176;
  t1490 = t64 * t1450 + t151 * (0.1e1 * t15 * t1462 - 0.1e1 * t55 * t1475) + 0.1e1 * t1487 * t168;
  t1501 = t64 * t1475 + t151 * (-0.1e1 * t168 * t1462 + 0.1e1 * t55 * t1450) + 0.1e1 * t1487 * t15;
  t1512 = t64 * t1462 + t151 * (0.1e1 * t168 * t1475 - 0.1e1 * t15 * t1450) + 0.1e1 * t1487 * t55;
  t1530 = t146 * t1437;
  t1536 = t146 * t1417;
  t1542 = t146 * t1427;
  t1571 = t71 * t113;
  t1573 = t74 * t118;
  t1576 = (-t111 * t70 + t1571 * t67 + t1573 * t67) * t14;
  t1583 = (-t111 * t88 + t1571 * t86 + t1573 * t86) * t14;
  t1587 = t69 * t71;
  t1589 = t69 * t74;
  t1592 = (-t111 * t66 - t113 * t1587 - t118 * t1589) * t14;
  t1595 = 0.1e1 * t1576 * t4 + 0.1e1 * t7 * t1583 + 0.1e1 * t1592 * t10;
  t1598 = t71 * t142;
  t1600 = t74 * t148;
  t1602 = -t138 * t70 + t1598 * t67 + t1600 * t67;
  t1608 = -0.1e1 * t1576 * t10 + 0.1e1 * t1592 * t4;
  t1613 = -t138 * t66 - t142 * t1587 - t148 * t1589;
  t1619 = 0.1e1 * t1576 * t7 - 0.1e1 * t4 * t1583;
  t1624 = -t138 * t88 + t1598 * t86 + t1600 * t86;
  t1630 = 0.1e1 * t10 * t1583 - 0.1e1 * t1592 * t7;
  t1638 = (t114 * t1630 + t120 * t1624 + t124 * t1619 + t130 * t1613 + t134 * t1608 + t140 * t1602) * t146;
  t1643 = t110 * t1602 + t114 * t1595 + t120 * t1613 + t124 * t1608 - t130 * t1624 - t134 * t1619 + t140 * t1638 + t147 * t1630 - t1595 * t360;
  t1655 = t110 * t1613 - t114 * t1608 - t120 * t1602 + t124 * t1595 + t130 * t1638 + t1630 * t134 + t140 * t1624 + t147 * t1619 - t1595 * t367;
  t1668 = t110 * t1624 + t114 * t1619 + t120 * t1638 - t124 * t1630 + t130 * t1602 + t134 * t1595 - t140 * t1613 + t147 * t1608 - t1595 * t377;
  t1680 = (0.1e1 * t168 * t1643 + 0.1e1 * t15 * t1668 + 0.1e1 * t55 * t1655) * t176;
  t1683 = t64 * t1643 + t151 * (0.1e1 * t15 * t1655 - 0.1e1 * t55 * t1668) + 0.1e1 * t1680 * t168;
  t1694 = t64 * t1668 + t151 * (-0.1e1 * t168 * t1655 + 0.1e1 * t55 * t1643) + 0.1e1 * t1680 * t15;
  t1705 = t64 * t1655 + t151 * (0.1e1 * t168 * t1668 - 0.1e1 * t15 * t1643) + 0.1e1 * t1680 * t55;
  t1723 = t146 * t1630;
  t1729 = t146 * t1608;
  t1735 = t146 * t1619;
  t1765 = -t97;
  t1766 = t1765 * t14;
  t1769 = 0.1e1 * t1766 * t4 + t127;
  t1773 = -t134;
  t1775 = t124 * t10;
  t1780 = 0.1e1 * t1766 * t7 - t85;
  t1782 = t10 * t114;
  t1786 = t10 * t134;
  t1791 = (0.1e1 * t83 * t1782 + t140 * t1773 - 0.1e1 * t1766 * t1786 + t154 + t1780 * t124) * t146;
  t1797 = t1769 * t114 + t110 * t1773 - 0.1e1 * t1766 * t1775 - t1780 * t134 - t161 + t1791 * t140 - t360 * t1769 + 0.1e1 * t147 * t116;
  t1809 = t1769 * t124 + 0.1e1 * t83 * t1786 + t141 + 0.1e1 * t1766 * t1782 - t120 * t1773 + t1791 * t130 - t367 * t1769 + t147 * t1780;
  t1823 = t1769 * t134 + t115 - 0.1e1 * t83 * t1775 + t1780 * t114 + t130 * t1773 + t1791 * t120 - t377 * t1769 - 0.1e1 * t147 * t1766 * t10;
  t1835 = (0.1e1 * t168 * t1797 + 0.1e1 * t15 * t1823 + 0.1e1 * t55 * t1809) * t176;
  t1838 = t64 * t1797 + t151 * (0.1e1 * t15 * t1809 - 0.1e1 * t55 * t1823) + 0.1e1 * t1835 * t168;
  t1849 = t64 * t1823 + t151 * (-0.1e1 * t168 * t1809 + 0.1e1 * t55 * t1797) + 0.1e1 * t1835 * t15;
  t1860 = t64 * t1809 + t151 * (0.1e1 * t168 * t1823 - 0.1e1 * t15 * t1797) + 0.1e1 * t1835 * t55;
  t1878 = t146 * t82;
  t1885 = t146 * t1765;
  t1892 = t146 * t1780;
  t1921 = 0.2e1 * t3 - t230;
  t1922 = t52 * t1921;
  t1925 = t4 * t1921;
  t1928 = t7 * t1921;
  t1931 = t10 * t1921;
  t1934 = -0.5000000000e0 * t235 * t1925 + t239 - 0.5000000000e0 * t240 * t1928 - 0.5000000000e0 * t244 * t1931;
  t1940 = -0.5000000000e0 * t240 * t1931 + 0.5000000000e0 * t244 * t1928;
  t1946 = 0.5000000000e0 * t235 * t1931 - 0.5000000000e0 * t244 * t1925 + t260;
  t1954 = -0.5000000000e0 * t235 * t1928 + 0.5000000000e0 * t240 * t1925 - t269;
  t1957 = (t1940 * t56 + t1946 * t58 + t1954 * t61) * t49;
  t1962 = -t1934 * t297 + t1934 * t61 + t1940 * t58 - t1946 * t56 + t1954 * t50 + t1957 * t45;
  t1965 = t60 * t1921;
  t1975 = -t309 * t1934 + t1934 * t58 - t1940 * t61 + t1946 * t50 + t1954 * t56 + t1957 * t37;
  t1978 = -0.5000000000e0 * t228 * t1922 + 0.1e1 * t15 * t1962 + 0.5000000000e0 * t284 * t1965 - 0.1e1 * t55 * t1975;
  t1986 = -0.5000000000e0 * t300 * t1925 + t303 - 0.5000000000e0 * t304 * t1928 - 0.5000000000e0 * t307 * t1931;
  t1992 = 0.5000000000e0 * t300 * t1931 - 0.5000000000e0 * t307 * t1925 + t316;
  t1998 = -0.5000000000e0 * t300 * t1928 + 0.5000000000e0 * t304 * t1925 - t323;
  t2004 = -0.5000000000e0 * t304 * t1931 + 0.5000000000e0 * t1928 * t307;
  t2009 = (t114 * t2004 + t124 * t1998 + t134 * t1992) * t146;
  t2014 = t114 * t1986 + t124 * t1992 - t134 * t1998 + t140 * t2009 + t147 * t2004 - t1986 * t360;
  t2016 = t156 * t1921;
  t2026 = -t114 * t1992 + t124 * t1986 + t130 * t2009 + t134 * t2004 + t147 * t1998 - t1986 * t367;
  t2029 = t163 * t1921;
  t2039 = t114 * t1998 + t120 * t2009 - t2004 * t124 + t134 * t1986 + t147 * t1992 - t1986 * t377;
  t2044 = t149 * t1921;
  t2058 = (-0.5000000000e0 * t373 * t2044 + t378 + 0.1e1 * t168 * t2014 - 0.5000000000e0 * t228 * t2029 + 0.1e1 * t15 * t2039 - 0.5000000000e0 * t284 * t2016 + 0.1e1 * t55 * t2026) * t176;
  t2061 = t373 * t1921;
  t2064 = t64 * t2014 + t151 * (-0.5000000000e0 * t228 * t2016 + 0.1e1 * t15 * t2026 + 0.5000000000e0 * t284 * t2029 - 0.1e1 * t55 * t2039) + 0.1e1 * t2058 * t168 - 0.5000000000e0 * t177 * t2061 + t397;
  t2070 = t188 * t1921;
  t2080 = -t1934 * t424 + t1934 * t56 + t1940 * t50 + t1946 * t61 - t1954 * t58 + t1957 * t31;
  t2083 = 0.5000000000e0 * t373 * t1922 - t403 - 0.1e1 * t168 * t1962 - 0.5000000000e0 * t284 * t2070 + 0.1e1 * t55 * t2080;
  t2098 = t228 * t1921;
  t2101 = t64 * t2039 + t151 * (0.5000000000e0 * t373 * t2016 - t425 - 0.1e1 * t168 * t2026 - 0.5000000000e0 * t284 * t2044 + 0.1e1 * t55 * t2014) + 0.1e1 * t2058 * t15 - 0.5000000000e0 * t177 * t2098;
  t2111 = -0.5000000000e0 * t373 * t1965 + t444 + 0.1e1 * t168 * t1975 + 0.5000000000e0 * t228 * t2070 - 0.1e1 * t15 * t2080;
  t2126 = t284 * t1921;
  t2129 = t64 * t2026 + t151 * (-0.5000000000e0 * t373 * t2029 + t457 + 0.1e1 * t168 * t2039 + 0.5000000000e0 * t228 * t2044 - 0.1e1 * t15 * t2014) + 0.1e1 * t2058 * t55 - 0.5000000000e0 * t177 * t2126;
  t2150 = t146 * t2004;
  t2153 = t516 * t1921;
  t2171 = (-0.5000000000e0 * t373 * t2070 + t567 + 0.1e1 * t168 * t2080 - 0.5000000000e0 * t228 * t1965 + 0.1e1 * t15 * t1975 - 0.5000000000e0 * t284 * t1922 + 0.1e1 * t55 * t1962) * t512;
  t2176 = t501 * t1962 + t503 * t2111 + 0.1e1 * t2171 * t55 - 0.5000000000e0 * t513 * t2126;
  t2179 = t523 * t1921;
  t2188 = t501 * t1975 + t503 * t2083 + 0.1e1 * t2171 * t15 - 0.5000000000e0 * t513 * t2098;
  t2197 = t146 * t1992;
  t2204 = t536 * t1921;
  t2213 = t501 * t2080 + t503 * t1978 + 0.1e1 * t2171 * t168 - 0.5000000000e0 * t513 * t2061 + t625;
  t2222 = t146 * t1998;
  t2268 = 0.2e1 * t17 - t692;
  t2269 = t52 * t2268;
  t2272 = t4 * t2268;
  t2275 = t7 * t2268;
  t2278 = t10 * t2268;
  t2281 = -0.5000000000e0 * t235 * t2272 - 0.5000000000e0 * t240 * t2275 + t269 - 0.5000000000e0 * t244 * t2278;
  t2287 = -0.5000000000e0 * t240 * t2278 + 0.5000000000e0 * t244 * t2275 - t260;
  t2293 = 0.5000000000e0 * t235 * t2278 - 0.5000000000e0 * t244 * t2272;
  t2301 = -0.5000000000e0 * t235 * t2275 + t239 + 0.5000000000e0 * t240 * t2272;
  t2304 = (t2287 * t56 + t2293 * t58 + t2301 * t61) * t49;
  t2309 = -t2281 * t297 + t2281 * t61 + t2287 * t58 - t2293 * t56 + t2301 * t50 + t2304 * t45;
  t2312 = t60 * t2268;
  t2322 = -t2281 * t309 + t2281 * t58 - t2287 * t61 + t2293 * t50 + t2301 * t56 + t2304 * t37;
  t2325 = -0.5000000000e0 * t228 * t2269 + t403 + 0.1e1 * t15 * t2309 + 0.5000000000e0 * t284 * t2312 - 0.1e1 * t55 * t2322;
  t2333 = -0.5000000000e0 * t300 * t2272 - 0.5000000000e0 * t304 * t2275 + t323 - 0.5000000000e0 * t307 * t2278;
  t2339 = 0.5000000000e0 * t300 * t2278 - 0.5000000000e0 * t307 * t2272;
  t2345 = -0.5000000000e0 * t300 * t2275 + t303 + 0.5000000000e0 * t304 * t2272;
  t2351 = -0.5000000000e0 * t304 * t2278 + 0.5000000000e0 * t307 * t2275 - t316;
  t2356 = (t114 * t2351 + t124 * t2345 + t134 * t2339) * t146;
  t2361 = t114 * t2333 + t124 * t2339 - t134 * t2345 + t140 * t2356 + t147 * t2351 - t2333 * t360;
  t2363 = t156 * t2268;
  t2373 = -t114 * t2339 + t124 * t2333 + t130 * t2356 + t134 * t2351 + t147 * t2345 - t2333 * t367;
  t2376 = t163 * t2268;
  t2386 = t114 * t2345 + t120 * t2356 - t124 * t2351 + t134 * t2333 + t147 * t2339 - t2333 * t377;
  t2391 = t149 * t2268;
  t2405 = (-0.5000000000e0 * t373 * t2391 + 0.1e1 * t168 * t2361 - 0.5000000000e0 * t228 * t2376 + t457 + 0.1e1 * t15 * t2386 - 0.5000000000e0 * t284 * t2363 + 0.1e1 * t55 * t2373) * t176;
  t2408 = t373 * t2268;
  t2411 = t64 * t2361 + t151 * (-0.5000000000e0 * t228 * t2363 + t425 + 0.1e1 * t15 * t2373 + 0.5000000000e0 * t284 * t2376 - 0.1e1 * t55 * t2386) + 0.1e1 * t2405 * t168 - 0.5000000000e0 * t177 * t2408;
  t2417 = t188 * t2268;
  t2427 = -t2281 * t424 + t2281 * t56 + t2287 * t50 + t2293 * t61 - t2301 * t58 + t2304 * t31;
  t2430 = 0.5000000000e0 * t373 * t2269 - 0.1e1 * t168 * t2309 - 0.5000000000e0 * t284 * t2417 + 0.1e1 * t55 * t2427;
  t2445 = t228 * t2268;
  t2448 = t64 * t2386 + t151 * (0.5000000000e0 * t373 * t2363 - 0.1e1 * t168 * t2373 - 0.5000000000e0 * t284 * t2391 + 0.1e1 * t55 * t2361) + 0.1e1 * t2405 * t15 - 0.5000000000e0 * t177 * t2445 + t397;
  t2458 = -0.5000000000e0 * t373 * t2312 + 0.1e1 * t168 * t2322 + 0.5000000000e0 * t228 * t2417 - t567 - 0.1e1 * t15 * t2427;
  t2473 = t284 * t2268;
  t2476 = t64 * t2373 + t151 * (-0.5000000000e0 * t373 * t2376 + 0.1e1 * t168 * t2386 + 0.5000000000e0 * t228 * t2391 - t378 - 0.1e1 * t15 * t2361) + 0.1e1 * t2405 * t55 - 0.5000000000e0 * t177 * t2473;
  t2497 = t146 * t2351;
  t2500 = t516 * t2268;
  t2518 = (-0.5000000000e0 * t373 * t2417 + 0.1e1 * t168 * t2427 - 0.5000000000e0 * t228 * t2312 + t444 + 0.1e1 * t15 * t2322 - 0.5000000000e0 * t284 * t2269 + 0.1e1 * t55 * t2309) * t512;
  t2523 = t501 * t2309 + t503 * t2458 + 0.1e1 * t2518 * t55 - 0.5000000000e0 * t513 * t2473;
  t2526 = t523 * t2268;
  t2535 = t501 * t2322 + t503 * t2430 + 0.1e1 * t2518 * t15 - 0.5000000000e0 * t513 * t2445 + t625;
  t2544 = t146 * t2339;
  t2551 = t536 * t2268;
  t2560 = t501 * t2427 + t503 * t2325 + 0.1e1 * t2518 * t168 - 0.5000000000e0 * t513 * t2408;
  t2569 = t146 * t2345;
  t2615 = 0.2e1 * t26 - t1042;
  t2616 = t52 * t2615;
  t2619 = t4 * t2615;
  t2622 = t7 * t2615;
  t2625 = t10 * t2615;
  t2628 = -0.5000000000e0 * t235 * t2619 - 0.5000000000e0 * t240 * t2622 - 0.5000000000e0 * t244 * t2625 + t260;
  t2634 = -0.5000000000e0 * t240 * t2625 + t269 + 0.5000000000e0 * t244 * t2622;
  t2640 = 0.5000000000e0 * t235 * t2625 - t239 - 0.5000000000e0 * t244 * t2619;
  t2648 = -0.5000000000e0 * t235 * t2622 + 0.5000000000e0 * t240 * t2619;
  t2651 = (t2634 * t56 + t2640 * t58 + t2648 * t61) * t49;
  t2656 = -t2628 * t297 + t2628 * t61 + t2634 * t58 - t2640 * t56 + t2648 * t50 + t2651 * t45;
  t2659 = t60 * t2615;
  t2669 = -t2628 * t309 + t2628 * t58 - t2634 * t61 + t2640 * t50 + t2648 * t56 + t2651 * t37;
  t2672 = -0.5000000000e0 * t228 * t2616 + 0.1e1 * t15 * t2656 + 0.5000000000e0 * t284 * t2659 - t444 - 0.1e1 * t55 * t2669;
  t2680 = -0.5000000000e0 * t300 * t2619 - 0.5000000000e0 * t304 * t2622 - 0.5000000000e0 * t307 * t2625 + t316;
  t2686 = 0.5000000000e0 * t300 * t2625 - t303 - 0.5000000000e0 * t307 * t2619;
  t2692 = -0.5000000000e0 * t300 * t2622 + 0.5000000000e0 * t304 * t2619;
  t2698 = -0.5000000000e0 * t304 * t2625 + t323 + 0.5000000000e0 * t307 * t2622;
  t2703 = (t114 * t2698 + t124 * t2692 + t134 * t2686) * t146;
  t2708 = t114 * t2680 + t124 * t2686 - t134 * t2692 + t140 * t2703 + t147 * t2698 - t2680 * t360;
  t2710 = t156 * t2615;
  t2720 = -t114 * t2686 + t124 * t2680 + t130 * t2703 + t134 * t2698 + t147 * t2692 - t2680 * t367;
  t2723 = t163 * t2615;
  t2733 = t114 * t2692 + t120 * t2703 - t124 * t2698 + t2680 * t134 + t147 * t2686 - t2680 * t377;
  t2738 = t149 * t2615;
  t2752 = (-0.5000000000e0 * t373 * t2738 + 0.1e1 * t168 * t2708 - 0.5000000000e0 * t228 * t2723 + 0.1e1 * t15 * t2733 - 0.5000000000e0 * t284 * t2710 + t425 + 0.1e1 * t55 * t2720) * t176;
  t2755 = t373 * t2615;
  t2758 = t64 * t2708 + t151 * (-0.5000000000e0 * t228 * t2710 + 0.1e1 * t15 * t2720 + 0.5000000000e0 * t284 * t2723 - t457 - 0.1e1 * t55 * t2733) + 0.1e1 * t2752 * t168 - 0.5000000000e0 * t177 * t2755;
  t2764 = t188 * t2615;
  t2774 = -t2628 * t424 + t2628 * t56 + t2634 * t50 + t2640 * t61 - t2648 * t58 + t2651 * t31;
  t2777 = 0.5000000000e0 * t373 * t2616 - 0.1e1 * t168 * t2656 - 0.5000000000e0 * t284 * t2764 + t567 + 0.1e1 * t55 * t2774;
  t2792 = t228 * t2615;
  t2795 = t64 * t2733 + t151 * (0.5000000000e0 * t373 * t2710 - 0.1e1 * t168 * t2720 - 0.5000000000e0 * t284 * t2738 + t378 + 0.1e1 * t55 * t2708) + 0.1e1 * t2752 * t15 - 0.5000000000e0 * t177 * t2792;
  t2805 = -0.5000000000e0 * t373 * t2659 + 0.1e1 * t168 * t2669 + 0.5000000000e0 * t228 * t2764 - 0.1e1 * t15 * t2774;
  t2820 = t284 * t2615;
  t2823 = t64 * t2720 + t151 * (-0.5000000000e0 * t373 * t2723 + 0.1e1 * t168 * t2733 + 0.5000000000e0 * t228 * t2738 - 0.1e1 * t15 * t2708) + 0.1e1 * t2752 * t55 - 0.5000000000e0 * t177 * t2820 + t397;
  t2844 = t146 * t2698;
  t2847 = t516 * t2615;
  t2865 = (-0.5000000000e0 * t373 * t2764 + 0.1e1 * t168 * t2774 - 0.5000000000e0 * t228 * t2659 + 0.1e1 * t15 * t2669 - 0.5000000000e0 * t284 * t2616 + t403 + 0.1e1 * t55 * t2656) * t512;
  t2870 = t501 * t2656 + t503 * t2805 + 0.1e1 * t2865 * t55 - 0.5000000000e0 * t513 * t2820 + t625;
  t2873 = t523 * t2615;
  t2882 = t501 * t2669 + t503 * t2777 + 0.1e1 * t2865 * t15 - 0.5000000000e0 * t513 * t2792;
  t2891 = t146 * t2686;
  t2898 = t536 * t2615;
  t2907 = t501 * t2774 + t503 * t2672 + 0.1e1 * t2865 * t168 - 0.5000000000e0 * t513 * t2755;
  t2916 = t146 * t2692;
  t2965 = t511 * t503;
  t2968 = -t503 * t52 + t501 * t207 + 0.1e1 * t2965 * t55;
  t2975 = -t503 * t60 + t501 * t191 + 0.1e1 * t2965 * t15;
  t2987 = -t503 * t188 + t501 * t63 + 0.1e1 * t2965 * t168;
  t2065 = beta / edge2LengthOriginal * (theta2 + referenceFrameTwist - t224);
  t2090 = t552 * t526;
  t2108 = t602 * t539;
  t2125 = t632 * t547;
  t2146 = t552 * t536;
  t2155 = t602 * t523;
  t2162 = t632 * t516;
  EnergyGradienti[0] = 0.2000000000e1 * t2065 * (-(t180 * t298 + t191 * t439 + t201 * t419 + t207 * t471 + t217 * t451 + t398 * t63) * t474 * t481 + (t180 * t416 + t188 * t398 + t201 * t295 + t217 * t281 + t439 * t60 + t471 * t52) * t219 * t491) + 0.2500000000e0 * t497 * (0.8000000000e1 * t551 * (-0.2e1 * t2090 * t310 + 0.2e1 * t556 * t526 + 0.2e1 * t500 * (-0.5000000000e0 * t228 * t559 + 0.1e1 * t15 * t584 + 0.5000000000e0 * t284 * t587 - 0.1e1 * t55 * t596) - 0.2e1 * t2108 * t310 + 0.2e1 * t606 * t539 + 0.2e1 * t529 * (0.5000000000e0 * t373 * t559 + t612 - 0.1e1 * t168 * t584 - 0.5000000000e0 * t284 * t615 + 0.1e1 * t55 * t626) - 0.2e1 * t2125 * t310 + 0.2e1 * t636 * t547 + 0.2e1 * t542 * (-0.5000000000e0 * t373 * t587 - t642 + 0.1e1 * t168 * t596 + 0.5000000000e0 * t228 * t615 - 0.1e1 * t15 * t626)) + 0.8000000000e1 * t662 * (0.2e1 * t2146 * t310 - 0.2e1 * t556 * t536 - 0.2e1 * t500 * t626 + 0.2e1 * t2155 * t310 - 0.2e1 * t606 * t523 - 0.2e1 * t529 * t596 + 0.2e1 * t2162 * t310 - 0.2e1 * t636 * t516 - 0.2e1 * t542 * t584));
  EnergyGradienti[1] = 0.2000000000e1 * t2065 * (-(t180 * t750 + t191 * t873 + t201 * t855 + t207 * t901 + t217 * t883 + t63 * t836) * t474 * t481 + (t180 * t852 + t188 * t836 + t201 * t747 + t217 * t734 + t52 * t901 + t60 * t873) * t219 * t491) + 0.2500000000e0 * t497 * (0.8000000000e1 * t551 * (-0.2e1 * t2090 * t758 + 0.2e1 * t922 * t526 + 0.2e1 * t500 * (-0.5000000000e0 * t228 * t925 - t612 + 0.1e1 * t15 * t948 + 0.5000000000e0 * t284 * t951 - 0.1e1 * t55 * t960) - 0.2e1 * t2108 * t758 + 0.2e1 * t969 * t539 + 0.2e1 * t529 * (0.5000000000e0 * t373 * t925 - 0.1e1 * t168 * t948 - 0.5000000000e0 * t284 * t976 + 0.1e1 * t55 * t985) - 0.2e1 * t2125 * t758 + 0.2e1 * t994 * t547 + 0.2e1 * t542 * (-0.5000000000e0 * t373 * t951 + 0.1e1 * t168 * t960 + 0.5000000000e0 * t228 * t976 + t1004 - 0.1e1 * t15 * t985)) + 0.8000000000e1 * t662 * (0.2e1 * t2146 * t758 - 0.2e1 * t922 * t536 - 0.2e1 * t500 * t985 + 0.2e1 * t2155 * t758 - 0.2e1 * t969 * t523 - 0.2e1 * t529 * t960 + 0.2e1 * t2162 * t758 - 0.2e1 * t994 * t516 - 0.2e1 * t542 * t948));
  EnergyGradienti[2] = 0.2000000000e1 * t2065 * (-(t1100 * t180 + t1186 * t63 + t1205 * t201 + t1223 * t191 + t1233 * t217 + t1251 * t207) * t474 * t481 + (t1084 * t217 + t1097 * t201 + t1186 * t188 + t1202 * t180 + t1223 * t60 + t1251 * t52) * t219 * t491) + 0.2500000000e0 * t497 * (0.8000000000e1 * t551 * (-0.2e1 * t2090 * t1108 + 0.2e1 * t1272 * t526 + 0.2e1 * t500 * (-0.5000000000e0 * t228 * t1275 + 0.1e1 * t15 * t1298 + 0.5000000000e0 * t284 * t1301 + t642 - 0.1e1 * t55 * t1310) - 0.2e1 * t2108 * t1108 + 0.2e1 * t1319 * t539 + 0.2e1 * t529 * (0.5000000000e0 * t373 * t1275 - 0.1e1 * t168 * t1298 - 0.5000000000e0 * t284 * t1326 - t1004 + 0.1e1 * t55 * t1335) - 0.2e1 * t2125 * t1108 + 0.2e1 * t1344 * t547 + 0.2e1 * t542 * (-0.5000000000e0 * t373 * t1301 + 0.1e1 * t168 * t1310 + 0.5000000000e0 * t228 * t1326 - 0.1e1 * t15 * t1335)) + 0.8000000000e1 * t662 * (0.2e1 * t2146 * t1108 - 0.2e1 * t1272 * t536 - 0.2e1 * t500 * t1335 + 0.2e1 * t2155 * t1108 - 0.2e1 * t1319 * t523 - 0.2e1 * t529 * t1310 + 0.2e1 * t2162 * t1108 - 0.2e1 * t1344 * t516 - 0.2e1 * t542 * t1298));
  EnergyGradienti[3] = 0.2000000000e1 * t2065 * (-(t1490 * t63 + t1501 * t191 + t1512 * t207) * t474 * t481 + (t1490 * t188 + t1501 * t60 + t1512 * t52) * t219 * t491) + 0.2500000000e0 * t497 * (0.8000000000e1 * t551 * (-0.2e1 * t2090 * t1407 + 0.2e1 * t1530 * t526 - 0.2e1 * t2108 * t1407 + 0.2e1 * t1536 * t539 - 0.2e1 * t2125 * t1407 + 0.2e1 * t1542 * t547) + 0.8000000000e1 * t662 * (0.2e1 * t2146 * t1407 - 0.2e1 * t1530 * t536 + 0.2e1 * t2155 * t1407 - 0.2e1 * t1536 * t523 + 0.2e1 * t2162 * t1407 - 0.2e1 * t1542 * t516));
  EnergyGradienti[4] = 0.2000000000e1 * t2065 * (-(t1683 * t63 + t1694 * t191 + t1705 * t207) * t474 * t481 + (t1683 * t188 + t1694 * t60 + t1705 * t52) * t219 * t491) + 0.2500000000e0 * t497 * (0.8000000000e1 * t551 * (-0.2e1 * t2090 * t1595 + 0.2e1 * t1723 * t526 - 0.2e1 * t2108 * t1595 + 0.2e1 * t1729 * t539 - 0.2e1 * t2125 * t1595 + 0.2e1 * t1735 * t547) + 0.8000000000e1 * t662 * (0.2e1 * t2146 * t1595 - 0.2e1 * t1723 * t536 + 0.2e1 * t2155 * t1595 - 0.2e1 * t1729 * t523 + 0.2e1 * t2162 * t1595 - 0.2e1 * t1735 * t516));
  EnergyGradienti[5] = 0.2000000000e1 * t2065 * (-(t1838 * t63 + t1849 * t191 + t1860 * t207) * t474 * t481 + (t1838 * t188 + t1849 * t60 + t1860 * t52) * t219 * t491) + 0.2500000000e0 * t497 * (0.8000000000e1 * t551 * (-0.2e1 * t2090 * t1769 + 0.2e1 * t1878 * t55 * t526 - 0.2e1 * t2108 * t1769 - 0.2e1 * t1885 * t55 * t539 - 0.2e1 * t2125 * t1769 + 0.2e1 * t1892 * t547) + 0.8000000000e1 * t662 * (0.2e1 * t2146 * t1769 - 0.2e1 * t1878 * t537 + 0.2e1 * t2155 * t1769 + 0.2e1 * t1885 * t524 + 0.2e1 * t2162 * t1769 - 0.2e1 * t1892 * t516));
  EnergyGradienti[6] = 0.2000000000e1 * t2065 * (-(t180 * t1978 + t191 * t2101 + t201 * t2083 + t2064 * t63 + t207 * t2129 + t2111 * t217) * t474 * t481 + (t180 * t2080 + t188 * t2064 + t1962 * t217 + t1975 * t201 + t2101 * t60 + t2129 * t52) * t219 * t491) + 0.2500000000e0 * t497 * (0.8000000000e1 * t551 * (-0.2e1 * t2090 * t1986 + 0.2e1 * t2150 * t526 + 0.2e1 * t500 * (-0.5000000000e0 * t228 * t2153 + 0.1e1 * t15 * t2176 + 0.5000000000e0 * t284 * t2179 - 0.1e1 * t55 * t2188) - 0.2e1 * t2108 * t1986 + 0.2e1 * t2197 * t539 + 0.2e1 * t529 * (0.5000000000e0 * t373 * t2153 - t612 - 0.1e1 * t168 * t2176 - 0.5000000000e0 * t284 * t2204 + 0.1e1 * t55 * t2213) - 0.2e1 * t2125 * t1986 + 0.2e1 * t2222 * t547 + 0.2e1 * t542 * (-0.5000000000e0 * t373 * t2179 + t642 + 0.1e1 * t168 * t2188 + 0.5000000000e0 * t228 * t2204 - 0.1e1 * t15 * t2213)) + 0.8000000000e1 * t662 * (0.2e1 * t2146 * t1986 - 0.2e1 * t2150 * t536 - 0.2e1 * t500 * t2213 + 0.2e1 * t2155 * t1986 - 0.2e1 * t2197 * t523 - 0.2e1 * t529 * t2188 + 0.2e1 * t2162 * t1986 - 0.2e1 * t2222 * t516 - 0.2e1 * t542 * t2176));
  EnergyGradienti[7] = 0.2000000000e1 * t2065 * (-(t180 * t2325 + t191 * t2448 + t201 * t2430 + t207 * t2476 + t217 * t2458 + t2411 * t63) * t474 * t481 + (t180 * t2427 + t188 * t2411 + t201 * t2322 + t217 * t2309 + t2448 * t60 + t2476 * t52) * t219 * t491) + 0.2500000000e0 * t497 * (0.8000000000e1 * t551 * (-0.2e1 * t2090 * t2333 + 0.2e1 * t2497 * t526 + 0.2e1 * t500 * (-0.5000000000e0 * t228 * t2500 + t612 + 0.1e1 * t15 * t2523 + 0.5000000000e0 * t284 * t2526 - 0.1e1 * t55 * t2535) - 0.2e1 * t2108 * t2333 + 0.2e1 * t2544 * t539 + 0.2e1 * t529 * (0.5000000000e0 * t373 * t2500 - 0.1e1 * t168 * t2523 - 0.5000000000e0 * t284 * t2551 + 0.1e1 * t55 * t2560) - 0.2e1 * t2125 * t2333 + 0.2e1 * t2569 * t547 + 0.2e1 * t542 * (-0.5000000000e0 * t373 * t2526 + 0.1e1 * t168 * t2535 + 0.5000000000e0 * t228 * t2551 - t1004 - 0.1e1 * t15 * t2560)) + 0.8000000000e1 * t662 * (0.2e1 * t2146 * t2333 - 0.2e1 * t2497 * t536 - 0.2e1 * t500 * t2560 + 0.2e1 * t2155 * t2333 - 0.2e1 * t2544 * t523 - 0.2e1 * t529 * t2535 + 0.2e1 * t2162 * t2333 - 0.2e1 * t2569 * t516 - 0.2e1 * t542 * t2523));
  EnergyGradienti[8] = 0.2000000000e1 * t2065 * (-(t180 * t2672 + t191 * t2795 + t201 * t2777 + t207 * t2823 + t217 * t2805 + t2758 * t63) * t474 * t481 + (t180 * t2774 + t188 * t2758 + t201 * t2669 + t217 * t2656 + t2795 * t60 + t2823 * t52) * t219 * t491) + 0.2500000000e0 * t497 * (0.8000000000e1 * t551 * (-0.2e1 * t2090 * t2680 + 0.2e1 * t2844 * t526 + 0.2e1 * t500 * (-0.5000000000e0 * t228 * t2847 + 0.1e1 * t15 * t2870 + 0.5000000000e0 * t284 * t2873 - t642 - 0.1e1 * t55 * t2882) - 0.2e1 * t2108 * t2680 + 0.2e1 * t2891 * t539 + 0.2e1 * t529 * (0.5000000000e0 * t373 * t2847 - 0.1e1 * t168 * t2870 - 0.5000000000e0 * t284 * t2898 + t1004 + 0.1e1 * t55 * t2907) - 0.2e1 * t2125 * t2680 + 0.2e1 * t2916 * t547 + 0.2e1 * t542 * (-0.5000000000e0 * t373 * t2873 + 0.1e1 * t168 * t2882 + 0.5000000000e0 * t228 * t2898 - 0.1e1 * t15 * t2907)) + 0.8000000000e1 * t662 * (0.2e1 * t2146 * t2680 - 0.2e1 * t2844 * t536 - 0.2e1 * t500 * t2907 + 0.2e1 * t2155 * t2680 - 0.2e1 * t2891 * t523 - 0.2e1 * t529 * t2882 + 0.2e1 * t2162 * t2680 - 0.2e1 * t2916 * t516 - 0.2e1 * t542 * t2870));
  EnergyGradienti[9] = 0.2000000000e1 * t2065 + 0.2500000000e0 * t497 * (0.8000000000e1 * t551 * (0.2e1 * t500 * (0.1e1 * t15 * t2968 - 0.1e1 * t55 * t2975) + 0.2e1 * t529 * (-0.1e1 * t168 * t2968 + 0.1e1 * t55 * t2987) + 0.2e1 * t542 * (0.1e1 * t168 * t2975 - 0.1e1 * t15 * t2987)) + 0.8000000000e1 * t662 * (-0.2e1 * t500 * t2987 - 0.2e1 * t529 * t2975 - 0.2e1 * t542 * t2968));
}
